require_dependency 'user_management_rails/application_controller'

module UserManagementRails::Concerns::UserResource
  extend ActiveSupport::Concern

  def current_user_hash(raise_jwt_error = true)
    result = nil
    begin
      user_jwt = cookies[:jwt]
      result = UserManagementRails.decode_user(user_jwt) if user_jwt
    rescue => error
      raise if raise_jwt_error
      handle_error
    end
    result
  end

  def current_user_logout
    cookies.delete :jwt
  end

  private

  def handle_error
    cookies.delete :jwt
  end
end
