require_dependency 'user_management_rails/application_controller'

module UserManagementRails
  class LoginsController < ApplicationController
    def create
      if UserManagementRails.valid_jwt?(user_jwt)
        cookies[:jwt] = user_jwt
      else
        cookies.delete :jwt
      end
    end

    private

    def user_jwt
      permitted_params[:jwt]
    end

    def permitted_params
      params.permit(:jwt)
    end
  end
end
