require 'user_management_rails/engine'
require 'jwt'
require 'dotenv-rails'

module UserManagementRails
  def self.decode_user(jwt)
    # pub_key = OpenSSL::PKey::RSA.new(ENV['JWT_PUBLIC_KEY'])
    pub_key = OpenSSL::PKey::RSA.new(self.configuration.jwt_public_key)
    JWT.decode(jwt, pub_key, true, algorithm: 'RS256')[0]
  end

  def self.valid_jwt?(jwt)
    # pub_key = OpenSSL::PKey::RSA.new(ENV['JWT_PUBLIC_KEY'])
    pub_key = OpenSSL::PKey::RSA.new(self.configuration.jwt_public_key)
    begin
      JWT.decode(jwt, pub_key, true, algorithm: 'RS256')[0]
    rescue JWT::DecodeError
      return false
    end
    true
  end

  # initializers
  class << self
    attr_accessor :configuration
  end

  def self.configure
    self.configuration ||= Configuration.new
    yield(configuration)
  end

  class Configuration
    attr_accessor :um_key, :ringcaptcha_key, :jwt_public_key

    def initialize
      @um_key = nil
      @ringcaptcha_key = nil
      @jwt_public_key = nil
    end
  end

end
